Index: XIOS/trunk/src/interface/fortran_attr/izoom_axis_attr.F90
===================================================================
--- XIOS/trunk/src/interface/fortran_attr/izoom_axis_attr.F90	(revision 784)
+++ XIOS/trunk/src/interface/fortran_attr/izoom_axis_attr.F90	(revision 787)
@@ -12,52 +12,45 @@
 
   SUBROUTINE xios(set_zoom_axis_attr)  &
-    ( zoom_axis_id, zoom_begin, zoom_end, zoom_size )
+    ( zoom_axis_id, begin, n )
 
     IMPLICIT NONE
       TYPE(txios(zoom_axis))  :: zoom_axis_hdl
       CHARACTER(LEN=*), INTENT(IN) ::zoom_axis_id
-      INTEGER  , OPTIONAL, INTENT(IN) :: zoom_begin
-      INTEGER  , OPTIONAL, INTENT(IN) :: zoom_end
-      INTEGER  , OPTIONAL, INTENT(IN) :: zoom_size
+      INTEGER  , OPTIONAL, INTENT(IN) :: begin
+      INTEGER  , OPTIONAL, INTENT(IN) :: n
 
       CALL xios(get_zoom_axis_handle)(zoom_axis_id,zoom_axis_hdl)
       CALL xios(set_zoom_axis_attr_hdl_)   &
-      ( zoom_axis_hdl, zoom_begin, zoom_end, zoom_size )
+      ( zoom_axis_hdl, begin, n )
 
   END SUBROUTINE xios(set_zoom_axis_attr)
 
   SUBROUTINE xios(set_zoom_axis_attr_hdl)  &
-    ( zoom_axis_hdl, zoom_begin, zoom_end, zoom_size )
+    ( zoom_axis_hdl, begin, n )
 
     IMPLICIT NONE
       TYPE(txios(zoom_axis)) , INTENT(IN) :: zoom_axis_hdl
-      INTEGER  , OPTIONAL, INTENT(IN) :: zoom_begin
-      INTEGER  , OPTIONAL, INTENT(IN) :: zoom_end
-      INTEGER  , OPTIONAL, INTENT(IN) :: zoom_size
+      INTEGER  , OPTIONAL, INTENT(IN) :: begin
+      INTEGER  , OPTIONAL, INTENT(IN) :: n
 
       CALL xios(set_zoom_axis_attr_hdl_)  &
-      ( zoom_axis_hdl, zoom_begin, zoom_end, zoom_size )
+      ( zoom_axis_hdl, begin, n )
 
   END SUBROUTINE xios(set_zoom_axis_attr_hdl)
 
   SUBROUTINE xios(set_zoom_axis_attr_hdl_)   &
-    ( zoom_axis_hdl, zoom_begin_, zoom_end_, zoom_size_ )
+    ( zoom_axis_hdl, begin_, n_ )
 
     IMPLICIT NONE
       TYPE(txios(zoom_axis)) , INTENT(IN) :: zoom_axis_hdl
-      INTEGER  , OPTIONAL, INTENT(IN) :: zoom_begin_
-      INTEGER  , OPTIONAL, INTENT(IN) :: zoom_end_
-      INTEGER  , OPTIONAL, INTENT(IN) :: zoom_size_
+      INTEGER  , OPTIONAL, INTENT(IN) :: begin_
+      INTEGER  , OPTIONAL, INTENT(IN) :: n_
 
-      IF (PRESENT(zoom_begin_)) THEN
-        CALL cxios_set_zoom_axis_zoom_begin(zoom_axis_hdl%daddr, zoom_begin_)
+      IF (PRESENT(begin_)) THEN
+        CALL cxios_set_zoom_axis_begin(zoom_axis_hdl%daddr, begin_)
       ENDIF
 
-      IF (PRESENT(zoom_end_)) THEN
-        CALL cxios_set_zoom_axis_zoom_end(zoom_axis_hdl%daddr, zoom_end_)
-      ENDIF
-
-      IF (PRESENT(zoom_size_)) THEN
-        CALL cxios_set_zoom_axis_zoom_size(zoom_axis_hdl%daddr, zoom_size_)
+      IF (PRESENT(n_)) THEN
+        CALL cxios_set_zoom_axis_n(zoom_axis_hdl%daddr, n_)
       ENDIF
 
@@ -65,52 +58,45 @@
 
   SUBROUTINE xios(get_zoom_axis_attr)  &
-    ( zoom_axis_id, zoom_begin, zoom_end, zoom_size )
+    ( zoom_axis_id, begin, n )
 
     IMPLICIT NONE
       TYPE(txios(zoom_axis))  :: zoom_axis_hdl
       CHARACTER(LEN=*), INTENT(IN) ::zoom_axis_id
-      INTEGER  , OPTIONAL, INTENT(OUT) :: zoom_begin
-      INTEGER  , OPTIONAL, INTENT(OUT) :: zoom_end
-      INTEGER  , OPTIONAL, INTENT(OUT) :: zoom_size
+      INTEGER  , OPTIONAL, INTENT(OUT) :: begin
+      INTEGER  , OPTIONAL, INTENT(OUT) :: n
 
       CALL xios(get_zoom_axis_handle)(zoom_axis_id,zoom_axis_hdl)
       CALL xios(get_zoom_axis_attr_hdl_)   &
-      ( zoom_axis_hdl, zoom_begin, zoom_end, zoom_size )
+      ( zoom_axis_hdl, begin, n )
 
   END SUBROUTINE xios(get_zoom_axis_attr)
 
   SUBROUTINE xios(get_zoom_axis_attr_hdl)  &
-    ( zoom_axis_hdl, zoom_begin, zoom_end, zoom_size )
+    ( zoom_axis_hdl, begin, n )
 
     IMPLICIT NONE
       TYPE(txios(zoom_axis)) , INTENT(IN) :: zoom_axis_hdl
-      INTEGER  , OPTIONAL, INTENT(OUT) :: zoom_begin
-      INTEGER  , OPTIONAL, INTENT(OUT) :: zoom_end
-      INTEGER  , OPTIONAL, INTENT(OUT) :: zoom_size
+      INTEGER  , OPTIONAL, INTENT(OUT) :: begin
+      INTEGER  , OPTIONAL, INTENT(OUT) :: n
 
       CALL xios(get_zoom_axis_attr_hdl_)  &
-      ( zoom_axis_hdl, zoom_begin, zoom_end, zoom_size )
+      ( zoom_axis_hdl, begin, n )
 
   END SUBROUTINE xios(get_zoom_axis_attr_hdl)
 
   SUBROUTINE xios(get_zoom_axis_attr_hdl_)   &
-    ( zoom_axis_hdl, zoom_begin_, zoom_end_, zoom_size_ )
+    ( zoom_axis_hdl, begin_, n_ )
 
     IMPLICIT NONE
       TYPE(txios(zoom_axis)) , INTENT(IN) :: zoom_axis_hdl
-      INTEGER  , OPTIONAL, INTENT(OUT) :: zoom_begin_
-      INTEGER  , OPTIONAL, INTENT(OUT) :: zoom_end_
-      INTEGER  , OPTIONAL, INTENT(OUT) :: zoom_size_
+      INTEGER  , OPTIONAL, INTENT(OUT) :: begin_
+      INTEGER  , OPTIONAL, INTENT(OUT) :: n_
 
-      IF (PRESENT(zoom_begin_)) THEN
-        CALL cxios_get_zoom_axis_zoom_begin(zoom_axis_hdl%daddr, zoom_begin_)
+      IF (PRESENT(begin_)) THEN
+        CALL cxios_get_zoom_axis_begin(zoom_axis_hdl%daddr, begin_)
       ENDIF
 
-      IF (PRESENT(zoom_end_)) THEN
-        CALL cxios_get_zoom_axis_zoom_end(zoom_axis_hdl%daddr, zoom_end_)
-      ENDIF
-
-      IF (PRESENT(zoom_size_)) THEN
-        CALL cxios_get_zoom_axis_zoom_size(zoom_axis_hdl%daddr, zoom_size_)
+      IF (PRESENT(n_)) THEN
+        CALL cxios_get_zoom_axis_n(zoom_axis_hdl%daddr, n_)
       ENDIF
 
@@ -118,64 +104,53 @@
 
   SUBROUTINE xios(is_defined_zoom_axis_attr)  &
-    ( zoom_axis_id, zoom_begin, zoom_end, zoom_size )
+    ( zoom_axis_id, begin, n )
 
     IMPLICIT NONE
       TYPE(txios(zoom_axis))  :: zoom_axis_hdl
       CHARACTER(LEN=*), INTENT(IN) ::zoom_axis_id
-      LOGICAL, OPTIONAL, INTENT(OUT) :: zoom_begin
-      LOGICAL(KIND=C_BOOL) :: zoom_begin_tmp
-      LOGICAL, OPTIONAL, INTENT(OUT) :: zoom_end
-      LOGICAL(KIND=C_BOOL) :: zoom_end_tmp
-      LOGICAL, OPTIONAL, INTENT(OUT) :: zoom_size
-      LOGICAL(KIND=C_BOOL) :: zoom_size_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: begin
+      LOGICAL(KIND=C_BOOL) :: begin_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: n
+      LOGICAL(KIND=C_BOOL) :: n_tmp
 
       CALL xios(get_zoom_axis_handle)(zoom_axis_id,zoom_axis_hdl)
       CALL xios(is_defined_zoom_axis_attr_hdl_)   &
-      ( zoom_axis_hdl, zoom_begin, zoom_end, zoom_size )
+      ( zoom_axis_hdl, begin, n )
 
   END SUBROUTINE xios(is_defined_zoom_axis_attr)
 
   SUBROUTINE xios(is_defined_zoom_axis_attr_hdl)  &
-    ( zoom_axis_hdl, zoom_begin, zoom_end, zoom_size )
+    ( zoom_axis_hdl, begin, n )
 
     IMPLICIT NONE
       TYPE(txios(zoom_axis)) , INTENT(IN) :: zoom_axis_hdl
-      LOGICAL, OPTIONAL, INTENT(OUT) :: zoom_begin
-      LOGICAL(KIND=C_BOOL) :: zoom_begin_tmp
-      LOGICAL, OPTIONAL, INTENT(OUT) :: zoom_end
-      LOGICAL(KIND=C_BOOL) :: zoom_end_tmp
-      LOGICAL, OPTIONAL, INTENT(OUT) :: zoom_size
-      LOGICAL(KIND=C_BOOL) :: zoom_size_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: begin
+      LOGICAL(KIND=C_BOOL) :: begin_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: n
+      LOGICAL(KIND=C_BOOL) :: n_tmp
 
       CALL xios(is_defined_zoom_axis_attr_hdl_)  &
-      ( zoom_axis_hdl, zoom_begin, zoom_end, zoom_size )
+      ( zoom_axis_hdl, begin, n )
 
   END SUBROUTINE xios(is_defined_zoom_axis_attr_hdl)
 
   SUBROUTINE xios(is_defined_zoom_axis_attr_hdl_)   &
-    ( zoom_axis_hdl, zoom_begin_, zoom_end_, zoom_size_ )
+    ( zoom_axis_hdl, begin_, n_ )
 
     IMPLICIT NONE
       TYPE(txios(zoom_axis)) , INTENT(IN) :: zoom_axis_hdl
-      LOGICAL, OPTIONAL, INTENT(OUT) :: zoom_begin_
-      LOGICAL(KIND=C_BOOL) :: zoom_begin__tmp
-      LOGICAL, OPTIONAL, INTENT(OUT) :: zoom_end_
-      LOGICAL(KIND=C_BOOL) :: zoom_end__tmp
-      LOGICAL, OPTIONAL, INTENT(OUT) :: zoom_size_
-      LOGICAL(KIND=C_BOOL) :: zoom_size__tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: begin_
+      LOGICAL(KIND=C_BOOL) :: begin__tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: n_
+      LOGICAL(KIND=C_BOOL) :: n__tmp
 
-      IF (PRESENT(zoom_begin_)) THEN
-        zoom_begin__tmp = cxios_is_defined_zoom_axis_zoom_begin(zoom_axis_hdl%daddr)
-        zoom_begin_ = zoom_begin__tmp
+      IF (PRESENT(begin_)) THEN
+        begin__tmp = cxios_is_defined_zoom_axis_begin(zoom_axis_hdl%daddr)
+        begin_ = begin__tmp
       ENDIF
 
-      IF (PRESENT(zoom_end_)) THEN
-        zoom_end__tmp = cxios_is_defined_zoom_axis_zoom_end(zoom_axis_hdl%daddr)
-        zoom_end_ = zoom_end__tmp
-      ENDIF
-
-      IF (PRESENT(zoom_size_)) THEN
-        zoom_size__tmp = cxios_is_defined_zoom_axis_zoom_size(zoom_axis_hdl%daddr)
-        zoom_size_ = zoom_size__tmp
+      IF (PRESENT(n_)) THEN
+        n__tmp = cxios_is_defined_zoom_axis_n(zoom_axis_hdl%daddr)
+        n_ = n__tmp
       ENDIF
 